@echo off
::
:: Note:  Lines beginning with "::" are inactive.
::
::-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@-<
::
:: PURPOSE:                                                                  )(
::                                                                   )(
:: This batch program will create and manage (on a Windows 9x machine) 10    )(
:: backup sets of the following 12 system files:                             )(
::                                                                           )(
::      in (C:\) directory:                                                  )(
::      -------------------                                                  )(
::           AUTOEXEC.BAT                                                    )(
::             CONFIG.SYS                                                    )(
::                 IO.SYS                                                    )(
::              MSDOS.SYS                                                    )(
::                                                                           )(
::      in (%winbootdir% / %windir%) [most likely (C:\Windows\)] directory:  )(
::      -------------------------------------------------------------------  )(
::            CONTROL.INI                                                    )(
::           DOSSTART.BAT                                                    )(
::              HOSTS                                                        )(
::           PROTOCOL.INI                                                    )(
::             SYSTEM.DAT (Windows Registry)                                 )(
::             SYSTEM.INI                                                    )(
::               USER.DAT (Windows Registry)                                 )(
::                WIN.INI                                                    )(
::                                                                           )(
::-------------------------------------------------------------------------<
::
:: REQUIREMENTS:                                                             !!
::                                                              !!
::  MS-DOS [*] Protected-mode ... (with Win9x ... running)                  !!
::          [*] Real-mode ........ (with Win9x NOT running)                  !!
::  MS-DOS External Command Program(s):                                     !!
::      ATTRIB.EXE                                                          !!
::      CHOICE.COM                                                          !!
::       DEBUG.EXE                                                          !!
::     DELTREE.EXE                                                          !!
::      EXPAND.EXE Win95 Setup cdrom...(\Other\Oldmsdos\), or...            !!
::                  ftp://ftp.microsoft.com/softlib/mslfiles/olddos.exe      !!
::          FC.EXE                                                          !!
::        FIND.EXE                                                          !!
::         MEM.EXE                                                          !!
::        MODE.COM                                                          !!
::        MORE.COM                                                          !!
::        MOVE.EXE                                                          !!
::     REGEDIT.EXE                                                          !!
::        SORT.EXE                                                          !!
::       START.EXE                                                          !!
::      WINSET.EXE Win95 Setup cdrom...(\Admin\Apptools\Envvars\), or...    !!
::                  ftp://ftp.microsoft.com/softlib/mslfiles/envars.exe      !!
::       XCOPY.EXE                                                          !!
::
:: REQUIREMENTS (Con'd):                                                     !!
::                                                      !!
::    BATCHMAN.COM (v1.1) (by Michael J Mefford)                            !!
::                  (MD5:  753c4c21960b59f5f59ad7e147ff081d  BATCHMAN.COM)   !!
::                  ftp://ftp.elf.stuba.sk/pub/pc/utiltask/batchman.zip      !!
::      DLOCK2.EXE (v2.00) (by Michael Paul Johnson)                        !!
::                  (MD5:  386100d035be57337fdd73927b5f28c9  DLOCK2.EXE)     !!
::                  ftp://ftp.elf.stuba.sk/pub/pc/security/dlock2.zip        !!
::                  http://ebible.org/mpj/software.htm                       !!
::    FREETEST.COM (by Eric Auer)                                           !!
::                  (MD5:  207e93220ea6fa033d3f48a30ddc5a64  FREETEST.COM)   !!
::                  http://www.coli.uni-saarland.de/~eric/                   !!
::                   stuff/soft/specials/free-disk-space-tester-freetest.zip !!
::     LONGADD.COM (v1.0) (by Clay Ruth)                                    !!
::                  (MD5:  fa738ad23a94d645783a08b4f4137573  LONGADD.COM)    !!
::                  ftp://ftp.elf.stuba.sk/pub/pc/utiltask/cutpak13.zip      !!
::                  http://clayruth.com/claysutl.html                        !!
::      MD5SUM.EXE (Branko Lankester, Colin Plumb, & Michael Paul Johnson)  !!
::                  (MD5:  ffbfbcc238f518b079dc8e00452c0ce1  MD5SUM.EXE)     !!
::                  ftp://ftp.elf.stuba.sk/pub/pc/security/md5sum.zip        !!
::                  http://ebible.org/mpj/software.htm                       !!
::                                                                           !!
::                                                                           !!
:: REQUIREMENTS (Con'd):                                                     !!
::                                                      !!
::     PKUNZIP.EXE (v2.50) (PKWARE)                                         !!
::                  (MD5:  0971de40b40a970b239a45b7379e4d0e  PKUNZIP.EXE)    !!
::                  ftp://ftp.elf.stuba.sk/pub/pc/pack/pk250dos.exe          !!
::                  http://www.pkware.com/                                   !!
::       PKZIP.EXE (v2.50) (PKWARE)                                         !!
::                  (MD5:  fb3a1925d98c6235d611a65595542c46  PKZIP.EXE)      !!
::                  ftp://ftp.elf.stuba.sk/pub/pc/pack/pk250dos.exe          !!
::                  http://www.pkware.com/                                   !!
::  OTHER:                                                                  !!
::         RFN.BAT (v1.3) (Blaware)                                         !!
::                  (MD5:  a63883b359464e913d1704fa246ccadf  RFN.BAT)        !!
::                  Requires:  MD5SUM.EXE / NSET.COM (v2.1)                  !!
::    YYYYMMDD.BAT (v1.3) (Blaware)                                         !!
::                  (MD5:  ba007a166ae2e3ab025b0c3fe6908290  YYYYMMDD.BAT)   !!
::                  Requires:  RFN.BAT (v1.3) (Blaware)                      !!
::  File(s) on the system (as per "Purpose")                                !!
::                                                                           !!
::                                                                           !!
::                                                                           !!
::                                                                           !!
::                                                                           !!
::-------------------------------------------------------------------------<
::
:: OVERVIEW:                                                                 ][
::                                                                  ][
:: First off, this batch program, 9x Registry Revert, needs to be run under  ][
:: two operating system environments.  Run it under real-mode DOS, perhaps   ][
:: CALLed from the (AUTOEXEC.BAT) file when the computer is first booting,   ][
:: and then again under protected-mode DOS (after the computer has booted to ][
:: Windows).                                                                 ][
::                                                                           ][
:: When run under Windows, 9x Registry Revert creates (once per day at first ][
:: boot) a backup set of the relevant system files.  The backed-up files are ][
:: first compressed and zipped using PKZIP.  The ZIP file is then encrypted  ][
:: using DLOCK2.  The encrypted file is given the name of the current date   ][
:: in the form of "YYYYMMDD" and stored in the (C:\Bat\9xRegRev\!Backups\)   ][
:: directory.  A maximum of 10 (the most recent) backup sets are kept.       ][
::                                                                           ][
:: When CALLed under real-mode DOS, 9x Registry Revert presents a menu.  The ][
:: menu offers the user the option to revert the system to a previously      ][
:: backed-up set of the relevant system files.  Also, it is under DOS that   ][
:: the number of stored backup sets is kept to just the 10 most recent.      ][
:: Note that this cleanup of the (C:\Bat\9xRegRev\!Backups\) directory means ][
:: that any personal files found there would not be safe from obliteration.  ][
:: Personal files or folders are safe if located in the (C:\Bat\9xRegRev\)   ][
:: directory, however (unless, of course, the "UNINSTALL" option is chosen). ][
::
::-------------------------------------------------------------------------<
::
:: NOTES:                                                                    ::
::                                                                     ::
::  It is recommended that (9xRegRev.bat) be located in the (C:\Bat\) or    ::
::   (C:\Bat\9xRegRev\) directory, though it may be located in the root      ::
::   directory of any drive.  It may NOT be located in the                   ::
::   (C:\Bat\9xRegRev\!Backups\) directory.  If located elsewhere, it should ::
::   be CALLed with it's full pathname (even if it's in one of the system's  ::
::   %PATH% directories); for example, [CALL Q:\Path\To\9xRegRev.bat].  For  ::
::   full installation instructions, see the (Readme.txt) file.              ::
::                                                                           ::
::  If problems are encountered running (9xRegRev.bat), it may be that a    ::
::   larger environment space is needed for it to operate in.  Evidence of   ::
::   this could be "Bad command or file name" errors or menus not displaying ::
::   properly.  Try running (9xRegRev.bat) with a command such as:           ::
::        [COMMAND C:\PATH\TO /E:nnnnn /C Q:\PATH\TO\9XREGREV.BAT]           ::
::   ("nnnnn" must be between 256 and 32768).  Bla recommends 32768 for      ::
::   nnnnn, as this would provide the maximum space of 32,768 bytes.         ::
::   Alternately, add a line to the system's (CONFIG.SYS) file, such as:     ::
::        [SHELL=C:\PATH\TO\COMMAND.COM /E:32768 /P]                         ::
::   This would apply the maximum environment space of 32,768 bytes          ::
::   globally, so that all DOS batch programs would have access to the large ::
::   environment space automatically.  BTW, the default environment size is  ::
::   just 256 bytes!                                                         ::
::
:: NOTES (Con'd):                                                            ::
::                                                             ::
::  If the creation of 1 backup set per boot-day is not the frequency       ::
::   desired, running (9xRegRev.bat) manually (whenever the creation of a    ::
::   backup set is desired) under Windows is fine.  However, it will only    ::
::   create one backup set per day, and the number of stored backup sets     ::
::   will only be pared back to the "10 most recent" when it is run under    ::
::   real-mode DOS (with Windows NOT running).                               ::
::                                                                           ::
::  If (9xRegRev.bat) is run in real-mode DOS after the system date is set  ::
::   back (say from 20010911 to 19991231) for some reason, all backup sets   ::
::   later than the "set-back" system date will be lost.                     ::
::                                                                           ::
::  (9xRegRev.bat) logs "LastBackupOn", "LastRevertOn", and "LastRevertTo"  ::
::   data in the Windows Registry here:                                      ::
::        [HKEY_CURRENT_USER\Software\Blaware\9xRegRev]                      ::
::                                                                           ::
::  Reload a documentation screen (Purpose, Requirements, Overview, Notes,  ::
::   and About) to toggle the color that the text is displayed in.  When a   ::
::   different documentation screen is loaded, the color remains the same.   ::
::                                                                           ::
::  Technical:  (9xRegRev.bat) MUST end with CR/LF (carriage return and     ::
::   line feed)...a blank line.                                              ::
::
:: NOTES (Con'd):                                                            ::
::                                                             ::
::  If editing (9xRegRev.bat), there are some technicalities to be made     ::
::   aware of.  See (Editing.txt) for more information on this topic.        ::
::                                                                           ::
::  If desired, the instance of (9xRegRev.bat) on the hard drive can be run ::
::   from a Win9x boot floppy disk.  Use (MakeFlop.bat) to create the boot   ::
::   floppy disk.  Open (MakeFlop.bat) in a text editor to read the details. ::
::                                                                           ::
::  (9xRegRev.bat) was partially adapted from code found here:              ::
::        http://www.ericphelps.com/                                         ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
::                                                                           ::
:: NOTES (Con'd):                                                            ::
::                                                             ::
::  To Uninstall [Via (9xRegRev.bat)]:                                      ::
::   ----------------------------------                                      ::
::   (1) Disable or remove any command that autoruns (9xRegRev.bat) under    ::
::       Windows (protected-mode DOS).                                       ::
::   (2) Run (9xRegRev.bat) under real-mode DOS.                             ::
::   (3) Choose the UNINSTALL option on the MAIN MENU.                       ::
::   (4) Disable or remove any command that autoruns (9xRegRev.bat) under    ::
::       real-mode DOS.                                                      ::
::   (5) Delete the (C:\Bat\9xRegRev\) directory if it still exists.         ::
::   (6) Delete the (C:\Bat\) directory and it's contents, if appropriate.   ::
::   (7) Delete (9xRegRev.bat), if desired.                                  ::
::                                                                           ::
::  To Uninstall (Manually):                                                ::
::   ------------------------                                                ::
::   (1) Delete the (C:\Bat\9xRegRev\) directory and it's contents.          ::
::   (2) Delete the (C:\Bat\) directory and it's contents, if appropriate.   ::
::   (3) Disable or remove any commands that autorun (9xRegRev.bat), both    ::
::       under DOS (real-mode) and Windows (protected-mode DOS).             ::
::   (4) Delete (9xRegRev.bat), if desired.                                  ::
::   (5) Delete [HKEY_CURRENT_USER\Software\Blaware\9xRegRev] in the Windows ::
::       Registry, and [HKEY_CURRENT_USER\Software\Blaware], if appropriate. ::
::
::-------------------------------------------------------------------------<
::                                                                   }{
::    :  : :  : Ŀ  }{
::                                                               }{
::  ABOUT:                                               (06-13-2009)    }{
::                                                                  }{
:: ں 9XREGREV.BAT (v1.3) is Blaware, and Blaware is freeware!           }{
:: ٺ                                                                    }{
::        Bla                                                             }{
::         P.O. Box NUL                                                 ں }{
::         Valley View, Ohio 44125 USA                                  ٺ }{
::                                                                        }{
::          E-Mail:   Blaware@FastMail.fm                                    }{
::         Webpage:  http://www.NUL.nul/index.html                       }{
::                                                                       }{
::  Feed the birds.  (Why?)  Well, they haven't pecked your eyes out!    }{
::                                                                        }{
:: ں                                                                    }{
:: ٺ                                                                    }{
::                                                                        }{
::                                                                      ں }{
::                                                              ٺ }{
::   :Ŀ::Ŀ  :    }{
::                                                                   }{
::-#######################################################################-<
::
ctty nul
echo z | find "z" > NUL
batchman month
if not errorlevel 1 goto 2Y
batchman cls 00h
for %%A in (Z9 Z8 Z7 Z6 Z5 Z3) do set %%A=
mode | find "Status for device CON:" > NUL
if errorlevel 1 goto 0K
mode | find "Columns=80" > NUL
if errorlevel 1 goto 0G
set Z9=80
goto 0H
:0G
mode | find "Columns=40" > NUL
if errorlevel 1 goto 0H
set Z9=40
:0H
mode | find "Lines=25" > NUL
if errorlevel 1 goto 0I
set Z8=25
goto 0K
:0I
mode | find "Lines=50" > NUL
if errorlevel 1 goto 0J
set Z8=50
goto 0K
:0J
mode | find "Lines=43" > NUL
if errorlevel 1 goto 0K
set Z8=43
:0K
ver | find "Windows 95" > NUL
if not errorlevel 1 goto 0L
ver | find "Windows 98" > NUL
if not errorlevel 1 goto 0L
set Z7=2Z
goto 0N
:0L
longadd /? | find "LONGADD.COM 1.0 - Long Addition for Batch Files - by Clay Ruth 05/12/1998" > NUL
if errorlevel 1 set Z7=LONGADD.COM (v1.0)
if not .%Z7%.==.. set Z6=.        
if not .%Z7%.==.. goto 0N
md5sum -b nuL | find "d41d8cd98f00b204e9800998ecf8427e *nuL" > NUL
if errorlevel 1 set Z7=MD5SUM.EXE
if not .%Z7%.==.. set Z6=.                
if not .%Z7%.==.. goto 0N
nset /? | find "NSET 2.1 (c) 1997 Horst Schaeffer - see DOC file" > NUL
if errorlevel 1 set Z7=NSET.COM (v2.1)
if not .%Z7%.==.. set Z6=.           
if not .%Z7%.==.. goto 0N
CALL YYYYMMDD.BAT 1 1 0 0 0 1 0 0 1
for %%B in (.%YYYYMMDD%. .%YYYY%. .%MM%. .%DD%.) do if .%%B.==.... set Z7=YYYYMMDD.BAT (v1.3)
if not .%Z7%.==.. set Z6=.       
if not .%Z7%.==.. goto 0N
mem /module:win | find "K)  " > NUL
if errorlevel 1 goto 0M
mem /module:vmm32 | find "K)  " > NUL
if errorlevel 1 goto 0M
if exist C:\Bat\9xRegRev\!Backups\%YYYYMMDD% goto 3X
set Z5=*
:0M
if not .%Z5%.==.*. set Z4=
if .%Z5%.==.*. winset /? | find "Sets or removes Windows master environment variables." > NUL
if .%Z5%.==.*. if errorlevel 2 goto 0N
if .%Z5%.==.*. if errorlevel 1 set Z7=WINSET.EXE
if not .%Z7%.==.. set Z6=.                
if not .%Z7%.==.. goto 0N
if .%Z5%.==.. winset /? | find "This program cannot be run in DOS mode." > NUL
if .%Z5%.==.. if errorlevel 2 goto 0N
if .%Z5%.==.. if errorlevel 1 set Z7=WINSET.EXE
if not .%Z7%.==.. set Z6=.                
if not .%Z7%.==.. goto 0N
if .%Z5%.==.. dlock2 | find "This program cannot be run in DOS mode." > NUL
if .%Z5%.==.. if errorlevel 2 goto 0N
if .%Z5%.==.. if not errorlevel 1 set Z7=DLOCK2.EXE (v2.00)
if not .%Z7%.==.. set Z6=.        
if not .%Z7%.==.. set Z4=*
if not .%Z7%.==.. goto 0N
dlock2 | find "Copyright (C) 1995 Michael Paul Johnson." > NUL
if errorlevel 1 set Z7=DLOCK2.EXE (v2.00)
if .%Z4%.==.*. set Z7=DLOCK2.EXE (v2.00)
if not .%Z7%.==.. set Z6=.        
if not .%Z7%.==.. goto 0N
expand /? | find "Expands one or more compressed files." > NUL
if errorlevel 1 set Z7=EXPAND.EXE
if not .%Z7%.==.. set Z6=.                
if not .%Z7%.==.. goto 0N
freetest /? | find "Public domain free disk space checker by EA 2004-2005" > NUL
if errorlevel 1 set Z7=FREETEST.COM
if not .%Z7%.==.. set Z6=.              
if not .%Z7%.==.. goto 0N
echo. | pkunzip | find "PKUNZIP (R)    FAST!    Extract Utility    Version 2.50" > NUL
if errorlevel 1 set Z7=PKUNZIP.EXE (v2.50)
if not .%Z7%.==.. set Z6=.       
if not .%Z7%.==.. goto 0N
echo. | pkzip | find "PKZIP (R)   FAST!   Create/Update Utility   Version 2.50" > NUL
if errorlevel 1 set Z7=PKZIP.EXE (v2.50)
if not .%Z7%.==.. set Z6=.         
:0N
ctty con
if .%Z7%.==.2Z. goto 2Z
if not .%Z7%.==.. goto 3G
c:
cd \
if not exist Bat\NUL if exist Bat set Z3=Bat
if not .%Z3%.==.. set Z6=).                    
if not .%Z3%.==.. goto 0O
if not exist Bat\NUL md Bat
cd Bat
if not exist 9xRegRev\NUL if exist 9xRegRev set Z3=Bat\9xRegRev
if not .%Z3%.==.. set Z6=).           
if not .%Z3%.==.. goto 0O
if not exist 9xRegRev\NUL md 9xRegRev
cd 9xRegRev
if not exist !Backups\NUL if exist !Backups set Z3=Bat\9xRegRev\!Backups
if not .%Z3%.==.. set Z6=).  
if not .%Z3%.==.. goto 0O
if not exist !Backups\NUL md !Backups
:0O
if not .%Z3%.==.. goto 3H
ctty nul
deltree /y @ > NUL
md @
if .%Z9%%Z8%.==.8025. goto 0P
mode con: cols=80 lines=25
:0P
if .%Z5%.==.*. goto 1X
ctty con
md @\&
if exist 9xRegRev.bat goto 1G
echo .%0. | find /i "9xRegRev.bat" > NUL
if errorlevel 1 goto 0Q
goto 0R
:0Q
echo .%0. | find /i "9xRegRev" > NUL
if errorlevel 1 goto 3J
:0R
echo .%0. | find ":\" > NUL
if errorlevel 1 goto 0S
if exist %0 goto 0Y
if exist %0.bat goto 0Z
:0S
if exist ..\9xRegRev.bat goto 0X
for %%C in (Z2 Z1) do set %%C=
echo .%0. | find "\" > NUL
if errorlevel 1 goto 0T
set Z2=%0
:0T
if .%Z1%.==.Z. goto 3K
if .%Z1%.==.Y. set Z1=Z
if .%Z1%.==.X. set Z1=Y
if .%Z1%.==.W. set Z1=X
if .%Z1%.==.V. set Z1=W
if .%Z1%.==.U. set Z1=V
if .%Z1%.==.T. set Z1=U
if .%Z1%.==.S. set Z1=T
if .%Z1%.==.R. set Z1=S
if .%Z1%.==.Q. set Z1=R
if .%Z1%.==.P. set Z1=Q
if .%Z1%.==.O. set Z1=P
if .%Z1%.==.N. set Z1=O
if .%Z1%.==.M. set Z1=N
if .%Z1%.==.L. set Z1=M
if .%Z1%.==.K. set Z1=L
if .%Z1%.==.J. set Z1=K
if .%Z1%.==.I. set Z1=J
if .%Z1%.==.H. set Z1=I
if .%Z1%.==.G. set Z1=H
if .%Z1%.==.F. set Z1=G
if .%Z1%.==.E. set Z1=F
if .%Z1%.==.D. set Z1=E
if .%Z1%.==.C. set Z1=D
if .%Z1%.==.A. set Z1=C
if .%Z1%.==.. set Z1=A
freetest %Z1%: | find "Cannot determine free space." > NUL
if not errorlevel 1 goto 0T
if exist %Z1%:\9xRegRev.bat goto 0W
if .%Z2%.==.. goto 0T
if exist %Z1%:\%Z2% goto 0U
if exist %Z1%:\%Z2%.bat goto 0V
goto 0T
:0U
set Z0=%Z1%:\%Z2%
type %Z0% | find /v "$B" > @\&\$A.TMP
goto 1H
:0V
set Z0=%Z1%:\%Z2%.bat
type %Z0% | find /v "$B" > @\&\$A.TMP
goto 1H
:0W
set Z0=%Z1%:\9xRegRev.bat
type %Z0% | find /v "$B" > @\&\$A.TMP
goto 1H
:0X
set Z0=..\9xRegRev.bat
type %Z0% | find /v "$B" > @\&\$A.TMP
goto 1H
:0Y
set Z0=%0
type %Z0% | find /v "$B" > @\&\$A.TMP
goto 1H
:0Z
set Z0=%0.bat
type %Z0% | find /v "$B" > @\&\$A.TMP
goto 1H
:1G
set Z0=9xRegRev.bat
type %Z0% | find /v "$B" > @\&\$A.TMP
:1H
for %%D in (Z2 Z1) do set %%D=
if not exist @\&\$A.TMP goto 1I
md5sum @\&\$A.TMP > @\&\$B.TMP
type @\&\$B.TMP | find "78fbac9fd34b0acad47c0ef537ab0a05" > NUL
if errorlevel 1 goto 3I
:1I
deltree /y @\& > NUL
batchman numlock on
cls
echo  Ŀ
echo                                                                          
echo                             
echo                          
echo                           
echo                                                                             
echo                                                                              
echo    PRE MENU                                                                  
echo                                                                      
echo                                                                              
batchman cecho c 07h,   Press [
batchman cecho c 0Fh,0
batchman cecho c 07h,] (
batchman cecho c 0Fh,number ZERO
batchman cecho 07h,) to access 9x Registry Revert.                     
echo                                                                              
echo    Auto-ABORT in 5 seconds.                                                  
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                              
echo  
batchman cecho c 07h,    Type your choice ... [
batchman cecho c 0Fh,0
batchman cecho 07h,]
batchman setcursor 26,01
choice /c:0.123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ!#$&'()-@^_,=+;[]`{}~"*:?\ /n /t:.,7 > NUL
if errorlevel 2 goto 1Y
for %%E in (Y8 X4 X1 W6 DLOCK_KEY) do set %%E=
set Y9=0F
:1J
for %%F in (Y7 Y6 Y5 Y4 Y3 Y2 Y1 Y0 X9 X8 X7 X6 X3 X2) do set %%F=
if not exist !Backups\nul cd ..
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                             
batchman cecho c 0Fh,   MAIN MENU                                    Today's Date :
batchman cecho c 0Dh, %MM%-%DD%-%YYYY%
batchman cecho 0Fh,   
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                    
echo                                                                              
echo         Options:                                                             
batchman cecho c 0Fh, 
batchman cecho c 0Ah,       
batchman cecho 0Fh,                                                             
echo         [-] ... ABORT!                                                       
batchman cecho c 0Fh,        [7] ... Uninstall...(
batchman cecho c 0Bh,Please read "Notes" before uninstalling
batchman cecho 0Fh,)        
echo         [6] ... About                                                        
echo         [5] ... Notes                                                        
echo         [4] ... Overview                                                     
echo         [3] ... Requirements                                                 
echo         [2] ... Purpose                                                      
echo         [1] ... Verify Files' Paths...(See if backup/revert is doable)       
echo         [0] ... Menu: Backup Sets.....(View sets available for restoration)  
echo                                                                              
echo  
echo     Type your choice ... [0-7] [-]
batchman setcursor 26,01
choice /c:01234567- /n > NUL
if errorlevel 9 goto 3U
if errorlevel 8 goto 1T
if errorlevel 7 goto 1P
if errorlevel 6 goto 1O
if errorlevel 5 goto 1N
if errorlevel 4 goto 1M
if errorlevel 3 goto 1L
if errorlevel 2 goto 1K
goto 1W
:1K
set Y8=*
if exist C:\AUTOEXEC.BAT set Y7=[*]
if .%Y7%.==.. set Y7=[ ]
if exist C:\CONFIG.SYS set Y6=[*]
if .%Y6%.==.. set Y6=[ ]
if exist C:\IO.SYS set Y5=[*]
if .%Y5%.==.. set Y5=[ ]
if exist C:\MSDOS.SYS set Y4=[*]
if .%Y4%.==.. set Y4=[ ]
if exist %winbootdir%\CONTROL.INI set Y3=[*]
if .%Y3%.==.. set Y3=[ ]
if exist %winbootdir%\DOSSTART.BAT set Y2=[*]
if .%Y2%.==.. set Y2=[ ]
if exist %winbootdir%\HOSTS set Y1=[*]
if .%Y1%.==.. set Y1=[ ]
if exist %winbootdir%\PROTOCOL.INI set Y0=[*]
if .%Y0%.==.. set Y0=[ ]
if exist %winbootdir%\SYSTEM.DAT set X9=[*]
if .%X9%.==.. set X9=[ ]
if exist %winbootdir%\SYSTEM.INI set X8=[*]
if .%X8%.==.. set X8=[ ]
if exist %winbootdir%\USER.DAT set X7=[*]
if .%X7%.==.. set X7=[ ]
if exist %winbootdir%\WIN.INI set X6=[*]
if .%X6%.==.. set X6=[ ]
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                              
echo    VERIFY FILES' PATHS                                                       
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                                       
echo                                                                              
echo    THIS program can backup these 12 system files for future restoration.     
echo    For successful (backup/revert), all files MUST have "*" (path detected).  
echo                                                                              
echo                                                                              
echo             In C:\:   In Windows Installation Directory:                     
batchman cecho c 0Fh, 
batchman cecho c 0Bh,           
batchman cecho c 0Ah,   
batchman cecho 0Fh,                     
echo    AUTOEXEC.BAT %Y7%     CONTROL.INI %Y3%   SYSTEM.DAT %X9% (Windows Registry)  
echo      CONFIG.SYS %Y6%    DOSSTART.BAT %Y2%   SYSTEM.INI %X8%                     
echo          IO.SYS %Y5%       HOSTS     %Y1%     USER.DAT %X7% (Windows Registry)  
echo       MSDOS.SYS %Y4%    PROTOCOL.INI %Y0%      WIN.INI %X6%                     
echo                                                                              
echo                                                                              
echo  
echo     Press any key to continue...
batchman setcursor 26,01
pause > NUL
goto 1J
:1L
set X5=)(
goto 1Q
:1M
set X5=!!
goto 1Q
:1N
set X5=][
goto 1Q
:1O
set X5=::
goto 1Q
:1P
set X5=}{
:1Q
if .%X4%.==.. goto 1S
if .%Y8%.==.*. goto 1S
if not .%X5%.==.%X4%. goto 1S
if .%Y9%.==.07. goto 1R
if .%Y9%.==.0D. set Y9=07
if .%Y9%.==.0A. set Y9=0D
if .%Y9%.==.0E. set Y9=0A
if .%Y9%.==.0B. set Y9=0E
if .%Y9%.==.0C. set Y9=0B
if .%Y9%.==.0F. set Y9=0C
goto 1S
:1R
set Y9=0F
:1S
set X4=%X5%
set Y8=
batchman cls %Y9%h
type %Z0% | find " %X5%" | more
goto 1J
:1T
set Y8=*
cd @
set X3=*
goto 2W
:1U
batchman cls 0Fh
ctty nul
>  ENTER.BAT echo :LOOP
>> ENTER.BAT echo if not .%%X2%%.==.. set X2=%%X2%% %%5
>> ENTER.BAT echo if .%%X2%%.==.. set X2=%%5
>> ENTER.BAT echo shift
>> ENTER.BAT echo if not .%%5.==.. goto LOOP
call $C.BAT
>  $D.TMP echo .pa.%YYYY%.ss.%MM%.wo.%DD%.rd.
>> $D.TMP echo .%X2%.
type $D.TMP | find /c ".pa.%YYYY%.ss.%MM%.wo.%DD%.rd." > $D.TMP
type $D.TMP | find "2" > NUL
if errorlevel 1 goto 3L
set X3=#
set X2=
regedit /d HKEY_CURRENT_USER\Software\Blaware\9xRegRev > NUL
regedit /e $E.REG HKEY_CURRENT_USER\Software\Blaware > NUL
rem | choice /n /t:y,7 > nul
if not exist $E.REG goto 1V
type $E.REG | find /i "[HKEY_CURRENT_USER\Software\Blaware\" > NUL
if not errorlevel 1 goto 1V
type $E.REG | find "=" > NUL
if not errorlevel 1 goto 1V
type $E.REG | find "@" > NUL
if not errorlevel 1 goto 1V
regedit /d HKEY_CURRENT_USER\Software\Blaware > NUL
:1V
if exist $E.REG del $E.REG
if .%Z0%.==.9xRegRev.bat. cd ..
for %%G in (!Backups @) do if .%Z0%.==.9xRegRev.bat. deltree /y %%G > NUL
if not .%Z0%.==.9xRegRev.bat. cd ..\..
if not .%Z0%.==.9xRegRev.bat. deltree /y 9xRegRev > NUL
goto 3M
:1W
set Y8=*
if not exist !Backups\nul cd ..
if .%X1%.==.1. set X1=2
if .%X1%.==.. set X1=1
if .%X1%.==.2. goto 2I
:1X
ctty con
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                              
echo                                                                              
batchman cecho c 0Fh, 
batchman cecho c 0Eh,    
batchman cecho 0Fh,                                                                
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                     
batchman cecho 0Fh,            
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                 
batchman cecho 0Fh,            
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,          
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,        
batchman cecho 0Fh,           
batchman cecho c 0Fh, 
batchman cecho c 0Eh,           
batchman cecho 0Fh,  
batchman cecho c 0Fh, 
batchman cecho c 0Eh,             
batchman cecho 0Fh,  
batchman cecho c 0Fh, 
batchman cecho c 0Eh,                       
batchman cecho 0Fh,  
echo                                                                              
echo                                                                              
echo  
batchman setcursor 26,01
if .%Z5%.==.*. goto 3T
if not .%W6%.==.. goto 2X
:1Y
if .%X1%.==.. batchman cls 0Fh
if .%X1%.==.. if exist !Backups\%YYYYMMDD% goto 3U
if exist !Backups\%YYYYMMDD% goto 1Z
cd !Backups
if exist 2 del 2
if exist 2? del 2?
if exist 2?? del 2??
if exist 2??? del 2???
if exist 2???? del 2????
if exist 2????? del 2?????
if exist 2?????? del 2??????
if exist 20%%????? del 20%%?????
if exist 20?%%???? del 20?%%????
if exist 20??%%??? del 20??%%???
if exist 20???%%?? del 20???%%??
if exist 20????%%? del 20????%%?
if exist 20?????%% del 20?????%%
if exist 20(????? del 20(?????
if exist 20?(???? del 20?(????
if exist 20??(??? del 20??(???
if exist 20???(?? del 20???(??
if exist 20????(? del 20????(?
if exist 20?????( del 20?????(
if exist 20)????? del 20)?????
if exist 20?)???? del 20?)????
if exist 20??)??? del 20??)???
if exist 20???)?? del 20???)??
if exist 20????)? del 20????)?
if exist 20?????) del 20?????)
if exist 20~????? del 20~?????
if exist 20?~???? del 20?~????
if exist 20??~??? del 20??~???
if exist 20???~?? del 20???~??
if exist 20????~? del 20????~?
if exist 20?????~ del 20?????~
for %%H in (! # $ & ' - @ ^ _ ` { }) do if exist 20%%H????? del 20%%H?????
for %%I in (! # $ & ' - @ ^ _ ` { }) do if exist 20?%%I???? del 20?%%I????
for %%J in (! # $ & ' - @ ^ _ ` { }) do if exist 20??%%J??? del 20??%%J???
for %%K in (! # $ & ' - @ ^ _ ` { }) do if exist 20???%%K?? del 20???%%K??
for %%L in (! # $ & ' - @ ^ _ ` { }) do if exist 20????%%L? del 20????%%L?
for %%M in (! # $ & ' - @ ^ _ ` { }) do if exist 20?????%%M del 20?????%%M
for %%N in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist 20%%N????? del 20%%N?????
for %%O in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist 20?%%O???? del 20?%%O????
for %%P in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist 20??%%P??? del 20??%%P???
for %%Q in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist 20???%%Q?? del 20???%%Q??
for %%R in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist 20????%%R? del 20????%%R?
for %%S in (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist 20?????%%S del 20?????%%S
cd ..
:1Z
if exist !Backups\20?????? move !Backups\20?????? @ > NUL
deltree /y !Backups\*.* > NUL
set X0=
:2G
> $F.TMP dir @ /b
for %%T in (1 0) do echo %%T>> $F.TMP
> $F.TMP type $F.TMP | sort /r
expand < $F.TMP | find "Error -" > $G.BAT
echo set W9=%%6> ERROR.BAT
call $G.BAT
if .%W9%.==.1. goto 2H
longadd %YYYYMMDD% -%W9% > NUL
if errorlevel 1 del @\%W9%
if not exist @\%W9% goto 2G
if .%X0%.==.8. set X0=9
if .%X0%.==.7. set X0=8
if .%X0%.==.6. set X0=7
if .%X0%.==.5. set X0=6
if .%X0%.==.4. set X0=5
if .%X0%.==.3. set X0=4
if .%X0%.==.2. set X0=3
if .%X0%.==.1. set X0=2
if .%X0%.==.0. set X0=1
if .%X0%.==.. set X0=0
if exist @\%W9% set W8%X0%=%W9%
if exist @\%W9% move @\%W9% !Backups > NUL
if not .%X0%.==.9. goto 2G
:2H
for %%U in (X0 W9) do set %%U=
for %%V in ($F.TMP $G.BAT ERROR.BAT) do del %%V
deltree /y @\*.* > NUL
if .%X1%.==.. goto 3U
:2I
set W7=
if .%W80%.==.. set W80=--NONE--
if .%W81%.==.. set W81=--NONE--
if .%W82%.==.. set W82=--NONE--
if .%W83%.==.. set W83=--NONE--
if .%W84%.==.. set W84=--NONE--
if .%W85%.==.. set W85=--NONE--
if .%W86%.==.. set W86=--NONE--
if .%W87%.==.. set W87=--NONE--
if .%W88%.==.. set W88=--NONE--
if .%W89%.==.. set W89=--NONE--
cd @
:2J
set V5=
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                              
echo    BACKUP SETS                                                               
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                                               
echo                                                                              
batchman cecho c 0Fh,   Select a backup set for restoration (sorted by date ... "
batchman cecho c 0Bh,YYYY
batchman cecho c 0Dh,MM
batchman cecho c 0Ah,DD
batchman cecho 0Fh,").      
echo                                                                              
echo                                                                              
echo                                                                              
echo         Options:                                                             
batchman cecho c 0Fh, 
batchman cecho c 0Ah,       
batchman cecho 0Fh,                                                             
echo         [0] ... (%W80%)     [5] ... (%W85%)                            
echo         [1] ... (%W81%)     [6] ... (%W86%)                            
echo         [2] ... (%W82%)     [7] ... (%W87%)                            
echo         [3] ... (%W83%)     [8] ... (%W88%)     [-] ... ABORT!         
echo         [4] ... (%W84%)     [9] ... (%W89%)     [.] ... Cancel         
echo                                                                              
echo  
echo     Type your choice ... [0-9] [.] [-]
batchman setcursor 26,01
choice /c:0123456789.- /n > NUL
if errorlevel 12 goto 3U
if errorlevel 11 goto 1J
if errorlevel 10 goto 2K
if errorlevel 9 goto 2L
if errorlevel 8 goto 2M
if errorlevel 7 goto 2N
if errorlevel 6 goto 2O
if errorlevel 5 goto 2P
if errorlevel 4 goto 2Q
if errorlevel 3 goto 2R
if errorlevel 2 goto 2S
if errorlevel 1 goto 2T
:2K
if .%W89%.==.--NONE--. goto 2J
set W6=%W89%
set W5=W89
goto 2U
:2L
if .%W88%.==.--NONE--. goto 2J
set W6=%W88%
set W5=W88
goto 2U
:2M
if .%W87%.==.--NONE--. goto 2J
set W6=%W87%
set W5=W87
goto 2U
:2N
if .%W86%.==.--NONE--. goto 2J
set W6=%W86%
set W5=W86
goto 2U
:2O
if .%W85%.==.--NONE--. goto 2J
set W6=%W85%
set W5=W85
goto 2U
:2P
if .%W84%.==.--NONE--. goto 2J
set W6=%W84%
set W5=W84
goto 2U
:2Q
if .%W83%.==.--NONE--. goto 2J
set W6=%W83%
set W5=W83
goto 2U
:2R
if .%W82%.==.--NONE--. goto 2J
set W6=%W82%
set W5=W82
goto 2U
:2S
if .%W81%.==.--NONE--. goto 2J
set W6=%W81%
set W5=W81
goto 2U
:2T
if .%W80%.==.--NONE--. goto 2J
set W6=%W80%
set W5=W80
:2U
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                              
echo    CONFIRMATION                                                              
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                                              
echo                                                                              
batchman cecho c 0Fh,   [
batchman cecho c 0Dh,?
batchman cecho 0Fh,]  Are you sure you want to restore the Windows 9x Registry to a        
echo         backup set created on:                                               
echo                                                                              
batchman cecho c 0Fh,             (
batchman cecho c 0Bh,%W6%
batchman cecho 0Fh,)?                                                     
echo                                                                              
echo                                                                              
echo         Options:                                                             
batchman cecho c 0Fh, 
batchman cecho c 0Ah,       
batchman cecho 0Fh,                                                             
echo         [-] ... ABORT!                                                       
echo         [.] ... Cancel                                                       
batchman cecho c 0Fh,        [0] ... Yes...(
batchman cecho c 0Bh,Please write down the above date for reference
batchman cecho 0Fh,)       
echo                                                                              
echo  
echo     Type your choice ... [0] [.] [-]
batchman setcursor 26,01
choice /c:?0.- /n > NUL
if errorlevel 4 goto 3U
if errorlevel 3 goto 2J
if errorlevel 2 goto 2V
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                              
echo    PASSWORD HELP                                                             
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho 0Fh,                                                             
echo                                                                              
batchman cecho c 0Fh,   The (case sEnSiTiVe) password is:
batchman cecho c 0Eh,  pa
batchman cecho c 0Fh,.
batchman cecho c 0Bh,YYYY
batchman cecho c 0Fh,.
batchman cecho c 0Eh,ss
batchman cecho c 0Fh,.
batchman cecho c 0Dh,MM
batchman cecho c 0Fh,.
batchman cecho c 0Eh,wo
batchman cecho c 0Fh,.
batchman cecho c 0Ah,DD
batchman cecho c 0Fh,.
batchman cecho c 0Eh,rd
batchman cecho 0Fh,  where...       
echo                                                        
echo                                                                              
batchman cecho c 0Fh, 
batchman cecho c 0Bh,              YYYY
batchman cecho 0Fh, = 4-digit year   (from date of chosen backup set)        
batchman cecho c 0Fh, 
batchman cecho c 0Dh,                MM
batchman cecho 0Fh, = 2-digit month  (from date...)                          
batchman cecho c 0Fh, 
batchman cecho c 0Ah,                DD
batchman cecho 0Fh, = 2-digit date   (from date...)                          
batchman cecho c 0Fh, 
batchman cecho c 0Eh,       pa ss wo rd
batchman cecho 0Fh, = well, you know                                         
echo                                                                              
echo                                                                              
echo                                                                              
echo                                                                          :)  
echo                                                                              
echo  
echo     Press any key to continue...
batchman setcursor 26,01
pause > NUL
goto 2U
:2V
if not exist %W6% copy ..\!Backups\%W6% . > NUL
:2W
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                       Ŀ  
batchman cecho c 0Fh,   PASSWORD INPUT     Maximum Number Of Characters (including spaces):
batchman cecho c 0Bh,118
batchman cecho 0Fh,. 
batchman cecho c 0Fh, 
batchman cecho c 0Eh,  
batchman cecho c 0Bh,     
batchman cecho 0Fh,   
echo                                                                              
echo                       Ŀ    
batchman cecho c 0Fh,     Legal Characters:
batchman cecho c 0Ah,` ~ ! @ # $ ^ & * ( ) - _ + \ [ ] { } : ' " . / ?
batchman cecho 0Fh,,   
batchman cecho c 0Fh, 
batchman cecho c 0Ah,    
batchman cecho 0Fh,     
echo                                Ŀ          Ŀ      Ŀ             
batchman cecho c 0Fh,                       numbers 
batchman cecho c 0Ah,0-9
batchman cecho c 0Fh,, letters 
batchman cecho c 0Ah,A-Z
batchman cecho c 0Fh,, and 
batchman cecho c 0Ah,Space
batchman cecho 0Fh,.            
echo                                                             
echo                       Ŀ                          Ŀ  Ŀ    
batchman cecho c 0Fh,   Illegal Characters:
batchman cecho c 0Ch,= ; ,
batchman cecho c 0Fh,, leading and/or trailing 
batchman cecho c 0Ch,Space
batchman cecho c 0Fh,, 
batchman cecho c 0Ch,Percent
batchman cecho 0Fh,,   
batchman cecho c 0Fh, 
batchman cecho c 0Ch,  
batchman cecho 0Fh,                                 
echo                       Ŀ  Ŀ      Ŀ        
batchman cecho c 0Fh,                      
batchman cecho c 0Ch,Vertical Bar
batchman cecho c 0Fh,, 
batchman cecho c 0Ch,Less Than
batchman cecho c 0Fh,, and 
batchman cecho c 0Ch,Greater Than
batchman cecho 0Fh,.       
echo                                       
echo  
echo Please Enter Password:
fc /LB1 /N CON NUL | date | find "1:" > $C.BAT
if .%X3%.==.*. goto 1U
goto 1X
:2X
ctty nul
>  ENTER.BAT echo :LOOP
>> ENTER.BAT echo if not .%%DLOCK_KEY%%.==.. set DLOCK_KEY=%%DLOCK_KEY%% %%5
>> ENTER.BAT echo if .%%DLOCK_KEY%%.==.. set DLOCK_KEY=%%5
>> ENTER.BAT echo shift
>> ENTER.BAT echo if not .%%5.==.. goto LOOP
call $C.BAT
dlock2 -d -s %W6% %W6%.ZIP
set DLOCK_KEY=
pkunzip -e %W6%.ZIP > NUL
if errorlevel 1 set W7=*
type %W6%.ZIP | find "$H.BAT" > NUL
if errorlevel 1 set W7=*
type %W6%.ZIP | find "PK" > NUL
if errorlevel 1 set W7=*
for %%W in (AUTOEXEC.BAT MSDOS.SYS IO.SYS CONFIG.SYS $H.BAT) do if not exist %%W set W7=*
for %%X in (HOSTS DOSSTART.BAT PROTOCOL.INI CONTROL.INI) do if not exist %%X set W7=*
for %%Y in (USER.DAT SYSTEM.DAT WIN.INI SYSTEM.INI) do if not exist %%Y set W7=*
if .%W7%.==.*. goto 3N
echo .%W6%.| md5sum > $I.TMP
for %%Z in (AUTOEXEC.BAT MSDOS.SYS IO.SYS CONFIG.SYS) do type %%Z | md5sum >> $I.TMP
for %%a in (HOSTS DOSSTART.BAT PROTOCOL.INI CONTROL.INI) do type %%a | md5sum >> $I.TMP
for %%b in (USER.DAT SYSTEM.DAT WIN.INI SYSTEM.INI) do type %%b | md5sum >> $I.TMP
call $H.BAT
md5sum $I.TMP | find "%V5%" > NUL
if errorlevel 1 goto 3O
for %%c in (W89 W88 W87 W86 W85 W84 W83 W82 W81 W80 W5 V5) do set %%c=
for %%d in (AUTOEXEC.BAT MSDOS.SYS IO.SYS CONFIG.SYS) do attrib -h -r -s C:\%%d
for %%e in (HOSTS DOSSTART.BAT PROTOCOL.INI CONTROL.INI) do attrib -h -r -s %winbootdir%\%%e
for %%f in (USER.DAT SYSTEM.DAT WIN.INI SYSTEM.INI) do attrib -h -r -s %winbootdir%\%%f
for %%g in (AUTOEXEC.BAT MSDOS.SYS IO.SYS CONFIG.SYS) do copy %%g C:\ /y > NUL
for %%h in (HOSTS DOSSTART.BAT PROTOCOL.INI CONTROL.INI) do copy %%h %winbootdir% /y > NUL
for %%i in (USER.DAT SYSTEM.DAT WIN.INI SYSTEM.INI) do copy %%i %winbootdir% /y > NUL
for %%j in (MSDOS.SYS IO.SYS) do attrib +h +r +s C:\%%j
for %%k in (USER.DAT SYSTEM.DAT) do attrib +h +r +s %winbootdir%\%%k
>  $J.REG echo REGEDIT4
>> $J.REG echo.
>> $J.REG echo [HKEY_CURRENT_USER\Software\Blaware]
>> $J.REG echo.
>> $J.REG echo [HKEY_CURRENT_USER\Software\Blaware\9xRegRev]
>> $J.REG echo @="C:\\Bat\\9xRegRev"
>> $J.REG echo "LastRevertOn"="%YYYYMMDD%"
>> $J.REG echo "LastRevertTo"="%W6%"
>> $J.REG echo.
regedit $J.REG > NUL
ctty con
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
batchman cecho c 0Fh, 
batchman cecho c 0Ah,                                                                    
batchman cecho 0Fh,     
batchman cecho c 0Fh, 
batchman cecho c 0Ah,                          
batchman cecho 0Fh,     
batchman cecho c 0Fh, 
batchman cecho c 0Ah,                      
batchman cecho 0Fh,      
batchman cecho c 0Fh, 
batchman cecho c 0Ah,                      
batchman cecho 0Fh,        
echo                                                                              
echo                                                                              
echo    The Windows Registry (as well as the other relevant files) have been      
echo                                                                              
echo    successfully restored to the backup set created on:                       
echo                                                                              
batchman cecho c 0Fh,        (
batchman cecho c 0Bh,%W6%
batchman cecho 0Fh,).                                                          
echo                                                                              
echo                                                                              
batchman cecho c 0Fh,   Good
batchman cecho c 0Ah, *luck*
batchman cecho 0Fh, booting to Windows!                                           
echo                                                                          :)  
echo                                                                              
echo  
echo     Press any key to continue...
batchman setcursor 26,01
pause > NUL
mode con: cols=80 lines=50
batchman cls 0Fh
batchman setcursor 50,01
batchman waitfor 01
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
batchman waitfor 01
echo.
echo  Ŀ
echo  ۳
echo  ۳
echo  ۳
echo  ۳
echo  ۱۳
echo  ۱۰۳
echo  ۱۲۰۳
echo  ۱۲۲۰۳
echo  ۱۲۰۱۳
echo  ۱۰۱۰۳
echo  ۱  ۱۲۰۳
echo  ۱۱۲۲۰۳
echo  ۱۱۲۰۳
echo  ۱۲۱۰۳
echo  ۱۲۲۱  ۳
echo  ۱۲۰۳
echo  ۱۰۳
echo  ۱ ۳
echo  ۱ ۳
echo   ۳
echo  ۱۳
echo  ۱۲۰۲۲۲۰۳
echo  ۱ ۰۳
echo  ۱۲۰۲۲۲۰۳
echo  ۱۰۰۲۰۳
echo  ۱۲۰۲۰۲۲۰۳
echo  ۱۰۲۲۰۳
echo  ۱۲۲ ۰۰۳
echo  ۱۲۰ ۲۲۳
echo  ۱۲۲      ۰۳
echo  ۱۲۰ ۰۲۰Ŀ۳
echo  ۱۰۲                     Ŀ۳
echo  ۱۲۰۲۲۰                                     ۳
echo  ۱۲۲۲۰۳                  ۳
echo  ۱۲۰۲۲۳              ۳
echo  ۱۲۲۲۰۲۰۳             ۳
echo  ۱ ۰۳                                     ۳
echo  ۱۲۲۲۰۲۲۳                                     ۳
echo  ۱۲۰۲۲۲۰۳                ۳
echo  ۱۲۲۲۰۲۲۳                 ۳
echo  ۱۲۰۲۲۲۰۳                  ۳
echo                                                          ۳
echo  Ŀ                     ۳
echo  ۳
echo  ۳
echo  ۳
echo  
batchman waitfor 05
echo.
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
echo  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .  .                                                                            .
batchman waitfor 01
for %%l in (. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .) do echo%%l
mode con: cols=80 lines=25
goto 3U
:2Y
ctty con
cls
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
echo                                                                           
echo                                                           
echo                                                            
echo                                                              
echo                                                                              
echo                                                                              
echo    There is a problem with the required program:  BATCHMAN.COM (v1.1).       
echo                                                                              
echo    Check that the proper version is installed in one of the system's PATH    
echo                                                                              
echo    directories.                                                              
echo                                                                              
echo                                                                              
echo    THIS program (9xRegRev.bat) must now abort!                               
echo                                                                          :(  
echo                                                                              
echo  
echo     Press any key to continue...
pause > NUL
goto 3Y
:2Z
set W4=echo    The operating system, as far as can be determined, is not a version of    
set W3=::
set W2=::
set W1=echo    either Windows 95 or Windows 98.  A version of one of these operating     
set W0=::
set V9=::
set V8=echo    systems is required.                                                      
set V7=::
set V6=::
goto 3P
:3G
set W4=batchman cecho c 0Fh,   There is a problem with the required program:
set W3=batchman cecho c 0Bh,  %Z7%
set W2=batchman cecho 0Fh,%Z6%
set W1=echo    Check that the proper version is installed in one of the system's PATH    
set W0=::
set V9=::
set V8=echo    directories.                                                              
set V7=::
set V6=::
goto 3P
:3H
set W4=batchman cecho c 0Fh,   THIS program needs to create the directory:  (
set W3=batchman cecho c 0Bh,C:\%Z3%
set W2=batchman cecho 0Fh,%Z6%
set W1=echo    It appears that a file with that pathname already exists.  THIS program   
set W0=::
set V9=::
set V8=echo    will NOT delete that file in order to create the necessary directory.     
set V7=::
set V6=::
goto 3P
:3I
set W4=echo    Self-integrity check failed.                                              
set W3=::
set W2=::
set W1=echo    There exists the possibility that THIS batch program has been tampered    
set W0=::
set V9=::
set V8=echo    with.                                                                     
set V7=::
set V6=::
goto 3P
:3J
set W4=echo    Self-integrity check failed.                                              
set W3=::
set W2=::
set W1=echo    Check that THIS batch program's filename is correct.  It should be:       
set W0=::
set V9=::
set V8=batchman cecho c 0Fh,        (
set V7=batchman cecho c 0Bh,9xRegRev.bat
set V6=batchman cecho 0Fh,).                                                      
goto 3P
:3K
set W4=echo    Self-integrity check failed.  Check that THIS batch program is either:    
set W3=::
set W2=::
set W1=batchman cecho c 0Fh,        (1) In (
set W0=batchman cecho c 0Bh,C:\Bat
set V9=batchman cecho c 0Fh,), (
set V8=batchman cecho c 0Fh,        (2) CALLed with it's full pathname [eg. (
set V7=batchman cecho c 0Bh,X:\Path\To\9xRegRev.bat
set V6=batchman cecho 0Fh,)].  
goto 3P
:3L
set W4=echo    Removal of THIS program's folder, stored backup sets therein, and stored  
set W3=::
set W2=::
set W1=echo    registry information cannot be done at this time due to:                  
set W0=::
set V9=::
set V8=batchman cecho c 0Fh, 
set V7=batchman cecho c 0Bh,       Incorrect password
set V6=batchman cecho 0Fh,.                                                  
set W6=*
deltree /y *.* > NUL
goto 3P
:3M
set W4=echo    UNINSTALL COMPLETE:  THIS program's stored backup sets and registry data  
set W3=::
set W2=::
set W1=batchman cecho c 0Fh,   have been removed.  Manual removal of (
set W0=batchman cecho c 0Bh,C:\Bat\9xRegRev\
set V9=batchman cecho 0Fh,) may be needed.   
set V8=batchman cecho c 0Fh, 
set V7=batchman cecho c 0Ah,  *
set V6=batchman cecho 0Fh, To reinstall, "CALL" (9xRegRev.bat) under both (Real) DOS and Win9x.    
set W6=*
goto 3P
:3N
set W4=echo    The problem is most likely one of two things:                             
set W3=::
set W2=::
set W1=echo         (1) Incorrect password, or                                           
set W0=::
set V9=::
set V8=batchman cecho c 0Fh,        (2) Backup set from (
set V7=batchman cecho c 0Bh,%W6%
set V6=batchman cecho 0Fh,) is incomplete, invalid, or corrupt.   
del %W6%.ZIP
goto 3P
:3O
set W4=batchman cecho c 0Fh,   The backup set from (
set W3=batchman cecho c 0Bh,%W6%
set W2=batchman cecho 0Fh,) failed an integrity check.                 
set W1=echo                                                                              
set W0=::
set V9=::
set V8=echo                                                                              
set V7=::
set V6=::
del ..\!Backups\%W6%
deltree /y *.* > NUL
set %W5%=--NONE--
:3P
ctty con
batchman cls 0Fh
echo  Ŀ
echo                                                                           
echo                             
echo                           
echo                             
echo                                                                             
if .%X3%.==.#. goto 3Q
batchman cecho c 0Fh, 
batchman cecho c 0Ch,                              
batchman cecho 0Fh,                                           
batchman cecho c 0Fh, 
batchman cecho c 0Ch,              
batchman cecho 0Fh,                                           
batchman cecho c 0Fh, 
batchman cecho c 0Ch,              
batchman cecho 0Fh,                                            
batchman cecho c 0Fh, 
batchman cecho c 0Ch,              
batchman cecho 0Fh,                                             
goto 3R
:3Q
batchman cecho c 0Fh, 
batchman cecho c 0Ah,                      
batchman cecho 0Fh,                                                   
batchman cecho c 0Fh, 
batchman cecho c 0Ah,            
batchman cecho 0Fh,                                                   
batchman cecho c 0Fh, 
batchman cecho c 0Ah,            
batchman cecho 0Fh,                                                    
batchman cecho c 0Fh, 
batchman cecho c 0Ah,            
batchman cecho 0Fh,                                                     
:3R
echo                                                                              
echo                                                                              
%W4%
%W3%
%W2%
echo                                                                              
%W1%
%W0%
%V9%
echo .%V9%. | find ",), (." > NUL
if errorlevel 1 goto 3S
batchman cecho c 0Bh,C:\Bat\9xRegRev
batchman cecho 0Fh,), or a drive's root directory; or  
:3S
echo                                                                              
%V8%
%V7%
%V6%
echo                                                                              
echo                                                                              
if .%W6%.==.. batchman cecho c 0Fh,   THIS program (
if .%W6%.==.. batchman cecho c 0Bh,9xRegRev.bat
if .%W6%.==.. batchman cecho 0Fh,) must now abort!                               
if not .%W6%.==.. echo                                                                              
if not .%X3%.==.#. echo                                                                          :(  
if .%X3%.==.#. echo                                                                          :)  
echo                                                                              
echo  
echo     Press any key to continue...
batchman setcursor 26,01
pause > NUL
cls
for %%m in (Z7 Z6 W7 W4 W3 W2 W1 W0 V9 V8 V7 V6) do set %%m=
if .%Z5%.==.*. if .%Z4%.==.*. winset Z4=
if .%W6%.==.. goto 3U
if .%X3%.==.*. goto 1J
if .%X3%.==.#. goto 3U
goto 2J
:3T
cd @
>  $K.REG echo REGEDIT4
>> $K.REG echo.
>> $K.REG echo [HKEY_CURRENT_USER\Software\Blaware]
>> $K.REG echo.
>> $K.REG echo [HKEY_CURRENT_USER\Software\Blaware\9xRegRev]
>> $K.REG echo @="C:\\Bat\\9xRegRev"
>> $K.REG echo "LastBackupOn"="%YYYYMMDD%"
>> $K.REG echo.
start /w regedit /s $K.REG
batchman waitfor 08
for %%n in (AUTOEXEC.BAT MSDOS.SYS IO.SYS CONFIG.SYS) do xcopy C:\%%n . /h > NUL
for %%o in (HOSTS DOSSTART.BAT PROTOCOL.INI CONTROL.INI) do xcopy %windir%\%%o . /h > NUL
for %%p in (USER.DAT SYSTEM.DAT WIN.INI SYSTEM.INI) do xcopy %windir%\%%p . /h > NUL
echo .%YYYYMMDD%.| md5sum > $I.TMP
for %%q in (AUTOEXEC.BAT MSDOS.SYS IO.SYS CONFIG.SYS) do type %%q | md5sum >> $I.TMP
for %%r in (HOSTS DOSSTART.BAT PROTOCOL.INI CONTROL.INI) do type %%r | md5sum >> $I.TMP
for %%s in (USER.DAT SYSTEM.DAT WIN.INI SYSTEM.INI) do type %%s | md5sum >> $I.TMP
echo e 100 "set V5="> $L.TMP
echo n $H.BAT>> $L.TMP
for %%t in (rcx 07 w q) do echo %%t>> $L.TMP
debug < $L.TMP > NUL
type $I.TMP | md5sum >> $H.BAT
for %%u in ($I $L) do del %%u.TMP
pkzip -a %YYYYMMDD% $H.BAT > NUL
if errorlevel 1 goto 3U
for %%v in ($H.BAT $K.REG) do del %%v
pkzip -a -whs -jhrs %YYYYMMDD% * > NUL
if errorlevel 1 goto 3U
dlock2 -e -s %YYYYMMDD%.ZIP %YYYYMMDD% -ppa.%YYYY%.ss.%MM%.wo.%DD%.rd
cd ..
move @\%YYYYMMDD% !Backups > NUL
:3U
ctty nul
if .%Z9%%Z8%.==.8025. goto 3V
mode con: cols=%Z9% lines=%Z8%
:3V
if not .%Z3%.==.. goto 3W
if .%X3%.==.#. goto 3W
if not exist !Backups\nul cd ..
deltree /y @ > NUL
:3W
cd \
for %%w in (Z9 Z8 Z5 Z3 Z2 Z1 Z0 Y9 Y8 X5 X4 X3 X1 W89 W88 W87 W86 W85 W84 W83 W82 W81 W80 W6 W5) do set %%w=
:3X
for %%x in (YYYYMMDD YYYY MM DD) do set %%x=
ctty con
:3Y
cls
:END
